

#  Post an article to a news group
#  w is only set for a reply
proc post { g {rw ""} } {
	global news


	set ts [clock seconds]
	set from ""
	set id ""
	set ref ""

	update
	set w [formwindow $ts post "Post to $g"  "From:" "Newsgroups:" "Date:" "Subject:" "Attachment:"]

	set news($w,1) "$news(email) ($news(name))"
	set news($w,2) $g
	set news($w,3) [clock format [clock seconds] -format "%a, %d %b %Y %H:%M:%S"]
	set news($w,4) ""
	set news($w,5) ""
	#  Handle a reply
	set hesaid ""
	if { $rw != "" } {
		set count 1
		set line [$rw get $count.0 $count.end]
		while { $line != "" } {
			set l [split $line : ]
			set hdr [lindex $l 0]
			set bdy [string range $line [expr [string length $hdr] + 1] end] 
			switch $hdr {
				Subject { set news($w,4) [string trim $bdy " "] }
				From    { set from $bdy } 
				Message-ID    { set id $bdy } 
				References    { set ref $bdy } 
			}
		incr count
		set line [$rw get $count.0 $count.end]
		}
		if { [string compare [string range $news($w,4) 0 2] "Re:"] != 0 } {
			set news($w,4) "Re: $news($w,4)"
		}
		set hesaid [$rw get $count.0 end]
	}
	if { $hesaid != "" } {
		$w.main insert end "in message $id from $g\n$from wrote:\n"
		foreach line [split $hesaid "\n"] {
			$w.main insert end ">$line\n"
		}
	}
	$w.ok configure -command "set news($w,wait) 1"
	$w.cancel configure -command "set news($w,wait) 2"
	bind $w.uf.f5.e  <Tab> "focus $w.main;break"
	focus $w.uf.f4.e 

	set news($w,wait) 0

	tkwait variable news($w,wait)
	if { $news($w,wait) == 1 } {
		set news($ts) [connectit] 

		socksend $news($ts) "post"
		set res [readsock $news($ts)]
		if { [rescode $res 340] } {
		} else {
			socksend $news($ts) "From: $news($w,1)"
			socksend $news($ts) "Newsgroups: $news($w,2)"
			socksend $news($ts) "Date: $news($w,3)"
			socksend $news($ts) "Subject: $news($w,4)"
			socksend $news($ts) "X-NewsReader: $news(tclnews) $news(version)"
			if { [string compare $ref "" ] } {
				socksend $news($ts) "References: $ref $id"
			}
			socksend $news($ts) ""

			foreach line [split [$w.main get 1.0 end] "\n"] {
				if { $line == "." } {
					set line ".."
				}
				socksend $news($ts) "$line"
			}

			if { [file readable $news($w,5)] } {
				set fd [open $news($w,5) r]
				socksend $news($ts) "-------------   Attachment ($news($w,5)) -------------"
				while { [gets $fd line] >= 0 } {
					if { $line == "." } { set line ".." }
					socksend $news($ts) "$line"
				}
				close $fd
			}
			
			if { $news(sig) != "" } {
				foreach l [split $news(sig) "\n"] {
					if { $l == "." } { set l ".." }
					socksend $news($ts) "$l"
				}
			}
			socksend $news($ts) "\n."
			rescode [readsock $news($ts)] 240
		}
		disconnect $news($ts)
	}
	closewin $ts
}

