
proc read_group {} {
	global env news groups sgroups newsread newsunread order

	set news(.news,message) "Go to read news" 
	foreach idx [$news(glst) curselection] {
		set l1 [$news(glst) get $idx]
		set g [lindex [split $l1] 0]
		#  Get a time stamp for the Window name
		set ts [clock format [clock seconds] -format %H%M%S]
		set w ".$ts"
		set lst "G$ts"
		window $w readgrp $lst listbox Stop Done Save CatchUp UUDecode Post markread
		wm title $w "$g"
		set news($w,l1) "Group"
		set news($w,l2) "Group"
		bind $w.main <Double-1> "readart $g $ts"
		bind $w.main <3> "button3 %W %x %y {readart $g $ts}"
		bind $w.x    <1> "button3 %W %x %y {markread $g $ts}"
		
		#  Get a seperate connection for this window
		set news($w,message) "Connecting to server"
		$w.done configure -command "closewin $ts"
		update
		set news($ts)  [connectit]
		set news($w,message) "Reading headers for $g"
		update
		if { $news($ts) == "" } {
			unset news($ts) 
			destroy $w
			return
		}
		set news($w,stop) 0
		$w.stop configure -command "set news($w,stop) 1"
		$w.save configure -command "dnsave $w $g"
		$w.catchup configure -command "catchup $g $w" -text "Catch Up"
		if { $news(uudecode) == 1 } {
			$w.uudecode configure -command "dndecode $w $g"
		} else {
			pack forget $w.uudecode 
		}
		$w.post  configure -command "post $g"
		$w.markread  configure -text "Mark Read" -command "markread $g $ts"

		
		socksend $news($ts) "group $g"
		set news($w,message) "[readsock $news($ts)] xover($news(xover))"
		set news($g,low) [lindex [split $news($w,message) ] 2]
		set news($g,high) [lindex [split $news($w,message) ] 3]

		if { ![info exists news($g,count)] } {
			if { [count_group $g $news($ts)] == "" } {
				disconnect $news($ts)	
				closewin $ts
				return
			} else { 
				if { $news(showall) == 0 } {
					refilter
				}
			}
		}

		set count 0
		set got   0
		set news($g,order) ""
		set news($w,message) "Fetching Headers"
		setscale $w $news($g,count) 
		set news($w,scale) 0
		update
		foreach a [array names newsunread $g,*] {
			
		if { $news($w,stop) == 0 } {
		if { $news(xover) == 0 } {
			socksend $news($ts) "head $newsunread($a)"
			set res [readsock $news($ts)]
			if { [rescode $res 221] } {
				return
			}
			set path [readsock $news($ts)]
			set rfrom [readsock $news($ts)]
			set newsgrps [readsock $news($ts)]
			set subj [readsock $news($ts)]
			set sl [string length $subj]
			set subj [string range $subj 9 $sl]
			set date [readsock $news($ts)]
			set organization [readsock $news($ts)]
			set lines [readsock $news($ts)]
			set lines [string range $lines 6 end]
		} else {
			socksend $news($ts) "xover $newsunread($a)"
			set res [readsock $news($ts)]
			if { [rescode $res 224] } {
				closewin $w
				return
			}
			set res [readsock $news($ts)]
			set l [split $res "\t"]
			set subj [lindex $l 1]
			set rfrom [lindex $l 2]
			set date [lindex $l 3]
			set lines [lindex $l 7]
		}
			while { $res != "." } {
				set res [readsock $news($ts)]
			}

			set from [lindex [split $rfrom "(" ] 1]
			set from [lindex [split $from ")" ] 0]
			if { $from == "" } {
				set from [lindex [split $rfrom ] 1]
			}

			set str [list $newsunread($a) $from $subj $date $lines]
			
			# Prepare for sorting
			lappend news($g,order) $str

			incr count 
			if { $count > 5 } {
				incr news($w,scale) $count
				update 
				set count 0
			}
	} else {
		break
	}
			}
		pack forget $w.stop
		set news($w,message) "Sorting ..."
		setmsg $w
		update
		foreach l [lsort -command sortgrp $news($g,order)] {
			set str   [format "%-8.8s (%-4.4s)  %-20.20s %s" \
				[lindex $l 0] [lindex $l 4] [lindex $l 1] [lindex $l 2] ]
			$w.main insert end $str
			$w.x    insert end ""
			$w.seq  insert end ""
		}
		#$w.main see 1
		set news($w,message) "Process Complete"
		update
		disconnect $news($ts)	
		return
	}
	return
}
